    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ---------------
    028 * BlockFrame.java
    029 * ---------------
    030 * (C) Copyright 2007, 2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes:
    036 * --------
    037 * 16-Mar-2007 : Version 1 (DG);
    038 *
    039 */
    040
    041package org.jfree.chart.block;
    042
    043import java.awt.Graphics2D;
    044import java.awt.geom.Rectangle2D;
    045
    046import org.jfree.ui.RectangleInsets;
    047import org.jfree.util.PublicCloneable;
    048
    049/**
    050 * A block frame is a type of border that can be drawn around the outside of
    051 * any {@link AbstractBlock}.  Classes that implement this interface should
    052 * implement {@link PublicCloneable} OR be immutable.
    053 *
    054 * @since 1.0.5
    055 */
    056public interface BlockFrame {
    057
    058    /**
    059     * Returns the space reserved for the border.
    060     *
    061     * @return The space (never <code>null</code>).
    062     */
    063    public RectangleInsets getInsets();
    064
    065    /**
    066     * Draws the border by filling in the reserved space (in black).
    067     *
    068     * @param g2  the graphics device.
    069     * @param area  the area.
    070     */
    071    public void draw(Graphics2D g2, Rectangle2D area);
    072
    073}